﻿var _Product;
var _Screen = 1;
var _Panels;
var _PanelsCount;

function startApplication() {
    var blCheckedPin = checkPin();
    $('#footer-nav').show();
    $('#rates-download-error-nav').hide();

    if (!blCheckedPin) {
        $('#divContent0').show();
        $('#divContent1').hide();
    }
    else {
        $('#divContent1').show();
    }

    SelectProduct();
    $('#divpage').trigger('create');
}

/***************************************************************************************************************
 * UI events
 ***************************************************************************************************************/
$('#btnNext').click(function () {
	if($(this).hasClass('ui-disabled')){
		return;
	}
    ClickNext();
});

$('#btnBack').click(function () {
    if($(this).hasClass('ui-disabled')){
		return;
	}
    Clickback();
});

$("#selProduct").change(function () {
    SelectProduct();
});

$(document).on('keyup', '#ECMPin', function (e) {
    if (e.which == 13) {
        ClickNext();
    };
});

/***************************************************************************************************************
 * Navigation
 ***************************************************************************************************************/

function changeNavButtonState(btnSelector, isEnabled) {
    if (isEnabled) {
        $(btnSelector).removeClass('ui-disabled');
    } else {
        $(btnSelector).addClass('ui-disabled');
    }
}

function ClickNext() {
    if (_Screen == 0) {
        handlePinInput();
        return;
    }
    else if (_Screen == 1) {
        $('#divContent1').hide();
        $('#divContent2').show();
        changeNavButtonState('#btnBack', true);
        BuildPanels();
    }

    if (_Screen == _PanelsCount) {
        //On last panel
        changeNavButtonState('#btnBack', true);
        changeNavButtonState('#btnNext', false);
    }

    _Screen++;
    BuildPanel();
    $('#divpage').trigger('create');
}

function Clickback() {
    if (_Screen == 2) {
        $('#divContent2').hide();
        $('#divContent1').show();
        changeNavButtonState('#btnBack', false);
        changeNavButtonState('#btnNext', true);
    } else if (_Screen == 1) {
        changeNavButtonState('#btnBack', false);
        changeNavButtonState('#btnNext', true);
    } else {
        changeNavButtonState('#btnNext', true);
    }

    _Screen--;
    BuildPanel();
    $('#divpage').trigger('create');
}

function handlePinInput() {
    var PIN = 'ECM8785';

    if ($('#ECMPin').val() === PIN) {
        window.app.Helpers.setLocalStorageValue(app.localStorageKeys.ecmPin, PIN);
        $('#divContent0').hide();
        $('#divContent1').show();
        _Screen = 1;
    } else {
        window.app.Helpers.showNotification("Invalid PIN");
        $('#ECMPin').val('');
    }
}

function checkPin() {
    var pin = window.app.Helpers.getLocalStorageValue(app.localStorageKeys.ecmPin);

    if (pin.length > 0) {
        return true;
    }

    _Screen = 0;
    return false;
}

$(document).on('pageinit', function (event) {
    $("#footer").on('swipeleft', (function () {
        ClickNext();
    }));

    $("#footer").on('swiperight', (function () {
        Clickback();
    }));
});

/***************************************************************************************************************
 * Product selection
 ***************************************************************************************************************/
function SetupBenefitDropdowns(userClick) {
    if (userClick) {
        _Panels[_Screen - 2].Age = $("#selAge").val();
        _Panels[_Screen - 2].Ben1CA = 0;
        _Panels[_Screen - 2].Ben2CA = 0;
        _Panels[_Screen - 2].Ben3CA = 0;
        _Panels[_Screen - 2].Ben1Prem = 0;
        _Panels[_Screen - 2].Ben2Prem = 0;
        _Panels[_Screen - 2].Ben3Prem = 0;
    }
    var i = 0;
    while (_Product.LivesAssured[i].Name != _Panels[_Screen - 2].Role) { i++; }

    var j = 0;
    var html = "";
    var mandatoryBen = false;
    while (typeof _Product.LivesAssured[i].Benefits[j] !== "undefined") {
        switch (j) {
            case 0:
                _Panels[_Screen - 2].Ben1Name = _Product.LivesAssured[i].Benefits[j].Name;
                break;
            case 1:
                _Panels[_Screen - 2].Ben2Name = _Product.LivesAssured[i].Benefits[j].Name;
                break;
            case 2:
                _Panels[_Screen - 2].Ben3Name = _Product.LivesAssured[i].Benefits[j].Name;
                break;
        }

        // Check for maximUm benefits across lives
        if (!BenPerLifeExceeded(_Panels[_Screen - 2].Role, _Panels[_Screen - 2].RoleInstance, j, _Product.LivesAssured[i].Benefits[j].MaxAcrossLives)) {
            html += _Product.LivesAssured[i].Benefits[j].Name + "<br />";
            html += "<div><span class='SpanStyle'><select id='selBen" + (j + 1) + "' data-mini='true' data-corners='false' class='dropdowncolor' data-icon='custom-dropdown' data-native-menu='true' onChange='UpdatePanel();";

            // When a benefit is changed that is linked to child benefits then the child benefits must also be cleared
            if (_Product.LivesAssured[i].Benefits[j].SingleCoverAmount) {
                html += "ClearSubsequentRoleBenefits(" + (_Screen - 2) + ", \"" + _Product.LivesAssured[i].Benefits[j].Name + "\", \"" + _Panels[_Screen - 2].Role + "\");";
            }

            if (_Product.LivesAssured[i].Benefits[j].CoverNotLessThanLife != "") {
                html += "ClearSubsequentRoleBenefits(" + (_Screen - 2) + ", \"" + _Product.LivesAssured[i].Benefits[j].Name + "\", \"" + _Product.LivesAssured[i].Benefits[j].CoverNotLessThanLife + "\");";
            }

            html += "'>";

            if (_Product.LivesAssured[i].Benefits[j].Optional) {
                html += "<option disabled selected style='display:none;'>(Optional)</option>";
            }
            else {
                html += "<option disabled selected style='display:none;'>(Select)</option>";
                mandatoryBen = true;
            }

            // Only load optional benefits if the mandatory benefit is selected
            if (!(_Product.LivesAssured[i].Benefits[j].Optional && mandatoryBen && _Panels[_Screen - 2].Ben1CA == 0)) {
                var allowableCoverAmount = CheckAllowableCoverAmount(_Product.LivesAssured[i].Benefits[j], j);
                var maximumCoverAmount = CheckMaximumCoverAmount(_Product.LivesAssured[i].Benefits[j]);

                // Only add the allowable cover amount to the dropdown list
                if (allowableCoverAmount > 0 && $("#selAge").val() > 0) {
                    if ((j == 0 && _Panels[_Screen - 2].Ben1CA == allowableCoverAmount) ||
                        (j == 1 && _Panels[_Screen - 2].Ben2CA == allowableCoverAmount) ||
                        (j == 2 && _Panels[_Screen - 2].Ben3CA == allowableCoverAmount)) {
                        html += "<option selected value='" + allowableCoverAmount + "'>R " + allowableCoverAmount.format(2) + "</option>";
                    }
                    else {
                        html += "<option value='" + allowableCoverAmount + "'>R " + allowableCoverAmount.format(2) + "</option>";
                    }
                }
                else {
                    var k = 0;
                    while (typeof _Product.LivesAssured[i].Benefits[j].Rates[k] !== "undefined") {
                        if (_Product.LivesAssured[i].Benefits[j].Rates[k].StartAge <= $("#selAge").val() && _Product.LivesAssured[i].Benefits[j].Rates[k].EndAge >= $("#selAge").val() &&
                        (maximumCoverAmount == 0 || _Product.LivesAssured[i].Benefits[j].Rates[k].CoverAmount <= maximumCoverAmount)) {
                            if ((j == 0 && _Panels[_Screen - 2].Ben1CA == _Product.LivesAssured[i].Benefits[j].Rates[k].CoverAmount) ||
                            (j == 1 && _Panels[_Screen - 2].Ben2CA == _Product.LivesAssured[i].Benefits[j].Rates[k].CoverAmount) ||
                            (j == 2 && _Panels[_Screen - 2].Ben3CA == _Product.LivesAssured[i].Benefits[j].Rates[k].CoverAmount)) {
                                html += "<option selected value='" + _Product.LivesAssured[i].Benefits[j].Rates[k].CoverAmount + "'>R " + _Product.LivesAssured[i].Benefits[j].Rates[k].CoverAmount.format(2) + "</option>";
                            } else {
                                html += "<option value='" + _Product.LivesAssured[i].Benefits[j].Rates[k].CoverAmount + "'>R " + _Product.LivesAssured[i].Benefits[j].Rates[k].CoverAmount.format(2) + "</option>";
                            }
                        }
                        k++;
                    }
                }
            }
            html += "</select></span><span class='premium-container'>= Premium: <span class='premium-display' id='spnPremium" + (j + 1) + "'>R0.00</span></span></div>";
        }
        j++;
    }

    $("#benefits").html(html);

    // Reset the panel values if the option is no longer available in the dropdown
    if (isNaN(Number($("#selBen1").val()))) {
        _Panels[_Screen - 2].Ben1Prem = _Panels[_Screen - 2].Ben1CA = 0;
    }

    if (isNaN(Number($("#selBen2").val()))) {
        _Panels[_Screen - 2].Ben2Prem = _Panels[_Screen - 2].Ben2CA = 0;
    }

    if (isNaN(Number($("#selBen3").val()))) {
        _Panels[_Screen - 2].Ben3Prem = _Panels[_Screen - 2].Ben3CA = 0;
    }

    CalcPremium();
    $('#divpage').trigger('create');
}

function SelectProduct() {
    switch ($("#selProduct").val()) {
        case "Standard Funeral Plan":
            _Product = StandardFuneralPlanProduct();
            break;
        case "Accident Cover":
            _Product = AccidentCoverProduct();
            break;
        case "Burial Plan":
            _Product = BurialPlanProduct();
            break;
        case "Life Cover":
            _Product = LifeCoverProduct();
            break;
        case "Comprehensive Funeral Plan":
            _Product = ComprehensiveFuneralCoverProduct();
            break;
        case "Parents Funeral Plan":
            _Product = ParentsFuneralPlanProduct();
            break;
        case "Extended Family Funeral Plan":
            _Product = ExtendedFamilyFuneralProduct();
            break;
    }

    CalMinMaxAges();
    SetupLives();
    $('#divpage').trigger('create');
}

function SetupLives() {
    HideObject(_Product.MaxPrimaryLife == 0, '#tdMainMember');
    HideObject(_Product.MaxPrimaryLife == 0, '#tdMainMemberLabel');
    HideObject(_Product.MaxSpouse == 0, '#tdSpouse');
    HideObject(_Product.MaxSpouse == 0, '#tdSpouseLabel');
    HideObject(_Product.MaxChild == 0, '#tdChild');
    HideObject(_Product.MaxChild == 0, '#tdChildLabel');
    HideObject(_Product.MaxParent == 0, '#tdParent');
    HideObject(_Product.MaxExtended == 0, '#tdExtendedFamily');
    HideObject(_Product.MaxParent == 0, '#tdParentLabel');
    HideObject(_Product.MaxExtended == 0, '#tdExtendedFamilyLabel');
    SetupLivesCount(_Product.MaxPrimaryLife, "MainMember", _Product.MandatoryLife == "Primary Life");
    SetupLivesCount(_Product.MaxSpouse, "Spouse", _Product.MandatoryLife == "Spouse");
    SetupLivesCount(_Product.MaxChild, "Child", _Product.MandatoryLife == "Child");
    SetupLivesCount(_Product.MaxParent, "Parent", _Product.MandatoryLife == "Parent");
    SetupLivesCount(_Product.MaxExtended, "ExtendedFamily", _Product.MandatoryLife == "Extended Family");
}

function SetupLivesCount(count, object, condition) {
    var html = "<select id='sel" + object + "' data-mini='true' class='dropdowncolor' data-icon='custom-dropdown' data-corners='false'>";
    var start = 0;
    if (condition) {
        start = 1;
    }

    for (var i = start; i <= count; i++) {
        if (object != "MainMember") {
            if (i == 0) {
                html += "<option selected value = " + i + ">" + i + "</option>";
            }
            else {
                html += "<option value = " + i + ">" + i + "</option>";
            }
        }
        else {
            html += "<option selected value = " + i + ">" + i + "</option>";
        }
    }

    html += "</select>";
    $("#td" + object).html(html);
}


/***************************************************************************************************************
 * Panels
 ***************************************************************************************************************/
function BuildPanels() {
    _Panels = new Object();
    _PanelsCount = 0;

    if ($("#selMainMember").val() > 0) {
        _Panels[_PanelsCount++] = Panel("Primary Life", 1);
    }

    if ($("#selSpouse").val() > 0) {
        _Panels[_PanelsCount++] = Panel("Spouse", 1);
    }

    for (var i = 0; i < $("#selChild").val() ; i++) {
        _Panels[_PanelsCount++] = Panel("Child", i + 1);
    }

    for (var i = 0; i < $("#selParent").val() ; i++) {
        _Panels[_PanelsCount++] = Panel("Parent", i + 1);
    }

    for (var i = 0; i < $("#selExtendedFamily").val() ; i++) {
        _Panels[_PanelsCount++] = Panel("Extended Family", i + 1);
    }
}

function BuildPanel() {
    // Find the Life Assured record
    var i = 0;
    while (_Product.LivesAssured[i].Name != _Panels[_Screen - 2].Role) { i++; }

    if (_Panels[_Screen - 2].RoleInstance > 1) {
        $("#lifeAssured").text(_Panels[_Screen - 2].Role + " " + _Panels[_Screen - 2].RoleInstance);
    }
    else {
        $("#lifeAssured").text(_Panels[_Screen - 2].Role);
    }

    // Setup the age dropdown
    var html = "";

    for (j = _Product.LivesAssured[i].MinAge ; j <= _Product.LivesAssured[i].MaxAge; j++) {
        if (_Panels[_Screen - 2].Age == j) {
            html += "<option selected>" + j + "</option>";
        }
        else {
            html += "<option>" + j + "</option>";
        }
    }

    $("#spanAge").html("<span class='SpanStyle'>" +
        "<select id='selAge' onChange='SetupBenefitDropdowns(true);' data-mini='true' data-corners='false' class='dropdowncolor' data-icon='custom-dropdown' data-native-menu='true'>" +
        "<option disabled selected style='display:none;'>(Select)</option>" +
        html +
        "</select>" +
        "</span>");
    SetupBenefitDropdowns(false);
}

function UpdatePanel() {
    var i = 0;
    while (_Product.LivesAssured[i].Name != _Panels[_Screen - 2].Role) { i++; }

    _Panels[_Screen - 2].Ben1CA = 0;
    _Panels[_Screen - 2].Ben2CA = 0;
    _Panels[_Screen - 2].Ben3CA = 0;
    _Panels[_Screen - 2].Ben1Prem = 0;
    _Panels[_Screen - 2].Ben2Prem = 0;
    _Panels[_Screen - 2].Ben3Prem = 0;

    var j = 0;
    while (typeof _Product.LivesAssured[i].Benefits[j] !== "undefined") {
        var k = 0;
        while (typeof _Product.LivesAssured[i].Benefits[j].Rates[k] !== "undefined") {
            if (_Product.LivesAssured[i].Benefits[j].Rates[k].StartAge <= $("#selAge").val() && _Product.LivesAssured[i].Benefits[j].Rates[k].EndAge >= $("#selAge").val()) {
                if (j == 0 && $("#selBen1").val() == _Product.LivesAssured[i].Benefits[j].Rates[k].CoverAmount) {
                    if (_Product.LivesAssured[i].Benefits[j].SingleCoverAmount && $("#selBen1 option").length == 2) {
                        _Panels[_Screen - 2].Ben1Prem = 0;
                    }
                    else {
                        _Panels[_Screen - 2].Ben1Prem = _Product.LivesAssured[i].Benefits[j].Rates[k].Premium;
                    }
                    _Panels[_Screen - 2].Ben1CA = Number($("#selBen1").val());
                }
                if (j == 1 && $("#selBen2").val() == _Product.LivesAssured[i].Benefits[j].Rates[k].CoverAmount) {
                    if (_Product.LivesAssured[i].Benefits[j].SingleCoverAmount && $("#selBen1 option").length == 2) {
                        _Panels[_Screen - 2].Ben2Prem = 0;
                    }
                    else {
                        _Panels[_Screen - 2].Ben2Prem = _Product.LivesAssured[i].Benefits[j].Rates[k].Premium;
                    }
                    _Panels[_Screen - 2].Ben2CA = Number($("#selBen2").val());
                }
                if (j == 2 && $("#selBen3").val() == _Product.LivesAssured[i].Benefits[j].Rates[k].CoverAmount) {
                    if (_Product.LivesAssured[i].Benefits[j].SingleCoverAmount && $("#selBen1 option").length == 2) {
                        _Panels[_Screen - 2].Ben3Prem = 0;
                    }
                    else {
                        _Panels[_Screen - 2].Ben3Prem = _Product.LivesAssured[i].Benefits[j].Rates[k].Premium;
                    }
                    _Panels[_Screen - 2].Ben3CA = Number($("#selBen3").val());
                }
            }
            k++;
        }
        j++;
    }
    SetupBenefitDropdowns(false);
}


/***************************************************************************************************************
 * Initialize products
 ***************************************************************************************************************/
function BurialPlanProduct() {
    var product = new Object();
    product.MaxPrimaryLife = 1;
    product.MaxSpouse = 1;
    product.MaxChild = 8;
    product.MaxParent = 4;
    product.MaxExtended = 8;
    product.MandatoryLife = "Primary Life";

    product.LivesAssured = new Object();
    product.LivesAssured[0] = new LifeAssured("Primary Life", 1);
    product.LivesAssured[0].Benefits[0] = new Benefit("Funeral Benefit", "ECMQT5866203", false, "", false, 1, "", "");

    product.LivesAssured[1] = new LifeAssured("Spouse", 1);
    product.LivesAssured[1].Benefits[0] = new Benefit("Funeral Benefit", "ECMQT5866204", false, "", false, 1, "", "");

    product.LivesAssured[2] = new LifeAssured("Child", 8);
    product.LivesAssured[2].Benefits[0] = new Benefit("Funeral Benefit", "ECMQT5866205", false, "", true, 8, "", "");

    product.LivesAssured[3] = new LifeAssured("Parent", 4);
    product.LivesAssured[3].Benefits[0] = new Benefit("Funeral Benefit", "ECMQT5866206", false, "", false, 4, "", "");

    product.LivesAssured[4] = new LifeAssured("Extended Family", 8, "");
    product.LivesAssured[4].Benefits[0] = new Benefit("Funeral Benefit", "ECMQT5866207", false, "", false, 8, "", "");

    return product;
}

function AccidentCoverProduct() {
    var product = new Object();
    product.MaxPrimaryLife = 1;
    product.MaxSpouse = 1;
    product.MaxChild = 0;
    product.MaxParent = 0;
    product.MaxExtended = 0;
    product.MandatoryLife = "Primary Life";

    product.LivesAssured = new Object();
    product.LivesAssured[0] = new LifeAssured("Primary Life", 1);
    product.LivesAssured[0].Benefits[0] = new Benefit("Accident Benefit", "ECMQM5786174", false, "", false, 1, "", "Spouse");

    product.LivesAssured[1] = new LifeAssured("Spouse", 1);
    product.LivesAssured[1].Benefits[0] = new Benefit("Accident Benefit", "ECMQM5786175", false, "", false, 1, "Primary Life", "");

    return product;
}

function ExtendedFamilyFuneralProduct() {
    var product = new Object();
    product.MaxPrimaryLife = 0;
    product.MaxSpouse = 0;
    product.MaxChild = 0;
    product.MaxParent = 0;
    product.MaxExtended = 4;
    product.MandatoryLife = "Extended Family";

    product.LivesAssured = new Object();
    product.LivesAssured[0] = new LifeAssured("Extended Family", 4);
    product.LivesAssured[0].Benefits[0] = new Benefit("Extended Family Funeral Plan", "ECMQL5776173", false, "", false, 4, "", "");

    return product;
}

function LifeCoverProduct() {
    var product = new Object();
    product.MaxPrimaryLife = 1;
    product.MaxSpouse = 0;
    product.MaxChild = 0;
    product.MaxParent = 0;
    product.MaxExtended = 0;
    product.MandatoryLife = "Primary Life";

    product.LivesAssured = new Object();
    product.LivesAssured[0] = new LifeAssured("Primary Life", 1);
    product.LivesAssured[0].Benefits[0] = new Benefit("Life Cover", "ECMQN5796176", false, "Disability Cover", false, 1, "", "");
    product.LivesAssured[0].Benefits[1] = new Benefit("Disability Cover", "ECMQN5796177", true, "Life Cover", false, 1, "", "");

    return product;
}

function ComprehensiveFuneralCoverProduct() {
    var product = new Object();
    product.MaxPrimaryLife = 1;
    product.MaxSpouse = 1;
    product.MaxChild = 16;
    product.MaxParent = 4;
    product.MaxExtended = 4;
    product.MandatoryLife = "Primary Life";

    product.LivesAssured = new Object();
    product.LivesAssured[0] = new LifeAssured("Primary Life", 1);
    product.LivesAssured[0].Benefits[0] = new Benefit("Funeral Benefit", "ECMQK5766161", false, "", false, 1, "", "");
    product.LivesAssured[0].Benefits[1] = new Benefit("Tombstone Benefit", "ECMQK5766166", true, "", false, 1, "", "");

    product.LivesAssured[1] = new LifeAssured("Spouse", 1);
    product.LivesAssured[1].Benefits[0] = new Benefit("Funeral Benefit", "ECMQK5766162", false, "", false, 1, "", "");
    product.LivesAssured[1].Benefits[1] = new Benefit("Tombstone Benefit", "ECMQK5766167", true, "", false, 1, "", "");

    product.LivesAssured[2] = new LifeAssured("Child", 16);
    product.LivesAssured[2].Benefits[0] = new Benefit("Funeral Benefit", "ECMQK5766163", true, "", true, 8, "", "");
    product.LivesAssured[2].Benefits[1] = new Benefit("Comprehensive Education Benefit", "ECMQK5766222", true, "", false, 8, "", "");

    product.LivesAssured[3] = new LifeAssured("Parent", 4);
    product.LivesAssured[3].Benefits[0] = new Benefit("Funeral Benefit", "ECMQK5766164", false, "", false, 4, "", "");

    product.LivesAssured[4] = new LifeAssured("Extended Family", 4, "");
    product.LivesAssured[4].Benefits[0] = new Benefit("Funeral Benefit", "ECMQK5766165", false, "", false, 4, "", "");

    return product;
}

function ParentsFuneralPlanProduct() {
    var product = new Object();
    product.MaxPrimaryLife = 0;
    product.MaxSpouse = 0;
    product.MaxChild = 0;
    product.MaxParent = 4;
    product.MaxExtended = 0;
    product.MandatoryLife = "Parent";

    product.LivesAssured = new Object();
    product.LivesAssured[0] = new LifeAssured("Parent", 4);
    product.LivesAssured[0].Benefits[0] = new Benefit("Funeral Benefit", "ECMQP5846193", false, "", false, 4, "", "");

    return product;
}

function StandardFuneralPlanProduct() {
    var product = new Object();
    product.MaxPrimaryLife = 1;
    product.MaxSpouse = 1;
    product.MaxChild = 16;
    product.MaxParent = 4;
    product.MaxExtended = 8;
    product.MandatoryLife = "Primary Life";

    product.LivesAssured = new Object();
    product.LivesAssured[0] = new LifeAssured("Primary Life", 1);
    product.LivesAssured[0].Benefits[0] = new Benefit("Standard Funeral Benefit", "ECMQJ5756151", false, "Accident Benefit", false, 1, "", "");
    product.LivesAssured[0].Benefits[1] = new Benefit("Accident Benefit", "ECMQJ5756171", true, "Standard Funeral Benefit", false, 1, "", "");
    product.LivesAssured[0].Benefits[2] = new Benefit("Tombstone Benefit", "ECMQJ5756156", true, "", false, 1, "");

    product.LivesAssured[1] = new LifeAssured("Spouse", 1);
    product.LivesAssured[1].Benefits[0] = new Benefit("Standard Funeral Benefit", "ECMQJ5756152", false, "Accident Benefit", false, 1, "", "");
    product.LivesAssured[1].Benefits[1] = new Benefit("Accident Benefit", "ECMQJ5756172", true, "Standard Funeral Benefit", false, 1, "", "");
    product.LivesAssured[1].Benefits[2] = new Benefit("Tombstone Benefit", "ECMQJ5756157", true, "", false, 1, "");

    product.LivesAssured[2] = new LifeAssured("Child", 16);
    product.LivesAssured[2].Benefits[0] = new Benefit("Standard Funeral Benefit", "ECMQJ5756153", true, "", true, 8, "", "");
    product.LivesAssured[2].Benefits[1] = new Benefit("Standard Education Benefit", "ECMQJ5756220", true, "", false, 8, "", "");

    product.LivesAssured[3] = new LifeAssured("Parent", 4);
    product.LivesAssured[3].Benefits[0] = new Benefit("Standard Funeral Benefit", "ECMQJ5756154", false, "", false, 4, "", "");

    product.LivesAssured[4] = new LifeAssured("Extended Family", 8, "");
    product.LivesAssured[4].Benefits[0] = new Benefit("Standard Funeral Benefit", "ECMQJ5756155", false, "", false, 8, "", "");

    return product;
}

/***************************************************************************************************************
 * Calc and validation
 ***************************************************************************************************************/
function CalcPremium() {
    $("#spnPremium1").text("R " + _Panels[_Screen - 2].Ben1Prem.format(2));
    $("#spnPremium2").text("R " + _Panels[_Screen - 2].Ben2Prem.format(2));
    $("#spnPremium3").text("R " + _Panels[_Screen - 2].Ben3Prem.format(2));

    var totPremium = 0;
    var z = 0;
    while (typeof _Panels[z] !== "undefined") {
        totPremium += _Panels[z].Ben1Prem + _Panels[z].Ben2Prem + _Panels[z].Ben3Prem;
        z++;
    }
    $("#spnTotalPremium").text(totPremium.format(2));

    ValidateEducatorPoints();
}

function ValidateEducatorPoints() {
    var childEducatorPoints = 0;
    var z = 0;
    while (typeof _Panels[z] !== "undefined") {
        var coverAmount = 0;
        if (_Panels[z].Ben1Name == "Standard Education Benefit" ||
            _Panels[z].Ben1Name == "Comprehensive Education Benefit") {
            coverAmount = _Panels[z].Ben1CA;
        }

        if (_Panels[z].Ben2Name == "Standard Education Benefit" ||
            _Panels[z].Ben2Name == "Comprehensive Education Benefit") {
            coverAmount = _Panels[z].Ben2CA;
        }

        if (_Panels[z].Ben3Name == "Standard Education Benefit" ||
            _Panels[z].Ben3Name == "Comprehensive Education Benefit") {
            coverAmount = _Panels[z].Ben3CA;
        }

        if (coverAmount > 0 && coverAmount <= 2500) {
            childEducatorPoints++;
        }

        if (coverAmount > 2500 && coverAmount <= 5000) {
            childEducatorPoints += 2;
        }

        if (coverAmount > 5000 && coverAmount <= 7500) {
            childEducatorPoints += 3;
        }

        if (coverAmount > 7500 && coverAmount <= 10000) {
            childEducatorPoints += 4;
        }

        if (coverAmount > 10000 && coverAmount <= 15000) {
            childEducatorPoints += 6;
        }

        z++;
    }

    if (childEducatorPoints > 10) {
        var msg = "The total benefit points for the child standard educator benefit calculates to "
            + childEducatorPoints
            + " points.  The total calculated benefit points can not exceed 10 points.";
        window.app.Helpers.showNotification(msg);
    }
}

function LoadRates(benefitType) {
    var returnRates = new Object();
    var j = 0;
    for (var i = 0; i < rates.length; i++) {
        if (rates[i].BenefitType == benefitType) {
            returnRates[j] = new Rate(Number(rates[i].StartAge), Number(rates[i].EndAge), Number(rates[i].StartCoverAmount), Number(rates[i].Premium));
            j = j + 1;
        }
    }

    return returnRates;
}


function CheckAllowableCoverAmount(benefit, benIndex) {
    if (benefit.MatchBenefit != "") {
        if (benIndex > 0 && _Panels[_Screen - 2].Ben1Name == benefit.MatchBenefit && _Panels[_Screen - 2].Ben1CA > 0) {
            return _Panels[_Screen - 2].Ben1CA;
        }

        if (benIndex > 1 && _Panels[_Screen - 2].Ben2Name == benefit.MatchBenefit && _Panels[_Screen - 2].Ben2CA > 0) {
            return _Panels[_Screen - 2].Ben2CA;
        }
    }

    if (benefit.SingleCoverAmount) {
        for (var i = 0; i < _Screen - 2; i++) {
            if (_Panels[i].Role == _Panels[_Screen - 2].Role) {
                if (benIndex == 0 && _Panels[i].Ben1CA > 0) {
                    return _Panels[i].Ben1CA;
                }

                if (benIndex == 1 && _Panels[i].Ben2CA > 0) {
                    return _Panels[i].Ben2CA;
                }

                if (benIndex == 2 && _Panels[i].Ben3CA > 0) {
                    return _Panels[i].Ben3CA;
                }
            }
        }
    }

    return 0;
}

function CheckMaximumCoverAmount(benefit) {
    if (benefit.CoverNotGreaterThanLife == "") {
        return 0;
    }

    for (var i = 0; i < _Screen - 2; i++) {
        if (_Panels[i].Role == benefit.CoverNotGreaterThanLife) {
            if (benefit.Name == _Panels[i].Ben1Name && _Panels[i].Ben1CA > 0) {
                return _Panels[i].Ben1CA;
            }

            if (benefit.Name == _Panels[i].Ben2Name && _Panels[i].Ben2CA > 0) {
                return _Panels[i].Ben2CA;
            }

            if (benefit.Name == _Panels[i].Ben3Name && _Panels[i].Ben3CA > 0) {
                return _Panels[i].Ben3CA;
            }
        }
    }

    return 0;
}

function BenPerLifeExceeded(role, roleIndex, benIndex, maxBenPerLife) {
    var totBen = 0;
    var z = 0;

    while (typeof _Panels[z] !== "undefined") {
        if (_Panels[z].RoleInstance != roleIndex && _Panels[z].Role == role && ((benIndex == 0 && _Panels[z].Ben1CA > 0) || (benIndex == 1 && _Panels[z].Ben2CA > 0 || (benIndex == 2 && _Panels[z].Ben3CA > 0)))) {
            totBen++;
        }
        z++;
    }

    if (totBen >= maxBenPerLife) {
        return true;
    }
    else {
        return false;
    }
}

function CalMinMaxAges() {
    var i = 0;
    while (typeof _Product.LivesAssured[i] !== "undefined") {
        var j = 0;
        while (typeof _Product.LivesAssured[i].Benefits[j] !== "undefined") {
            var k = 0;
            while (typeof _Product.LivesAssured[i].Benefits[j].Rates[k] !== "undefined") {
                if (_Product.LivesAssured[i].Benefits[j].Rates[k].StartAge < _Product.LivesAssured[i].MinAge)
                    _Product.LivesAssured[i].MinAge = _Product.LivesAssured[i].Benefits[j].Rates[k].StartAge;
                if (_Product.LivesAssured[i].Benefits[j].Rates[k].EndAge > _Product.LivesAssured[i].MaxAge)
                    _Product.LivesAssured[i].MaxAge = _Product.LivesAssured[i].Benefits[j].Rates[k].EndAge;
                k++;
            }
            j++;
        }
        i++;
    }
}

function ClearSubsequentRoleBenefits(panelIndex, benName, role) {
    var z = panelIndex + 1;
    while (typeof _Panels[z] !== "undefined" && _Panels[z].Role == role) {
        if (_Panels[z].Ben1Name == benName) {
            _Panels[z].Ben1Prem = _Panels[z].Ben1CA = 0;
        }

        if (_Panels[z].Ben2Name == benName) {
            _Panels[z].Ben2Prem = _Panels[z].Ben2CA = 0;
        }

        if (_Panels[z].Ben3Name == benName) {
            _Panels[z].Ben3Prem = _Panels[z].Ben3CA = 0;
        }

        z++;
    }
}

/***************************************************************************************************************
 * Constructors
 ***************************************************************************************************************/
function Panel(role, roleInstance, age) {
    var panel = new Object();
    panel.Role = role;
    panel.RoleInstance = roleInstance;
    panel.Age = age;
    panel.Ben1Name = "";
    panel.Ben1CA = 0;
    panel.Ben1Prem = 0;
    panel.Ben2Name = "";
    panel.Ben2CA = 0;
    panel.Ben2Prem = 0;
    panel.Ben3Name = "";
    panel.Ben3CA = 0;
    panel.Ben3Prem = 0;
    return panel;
}

function LifeAssured(name, number) {
    var lifeAssured = new Object;
    lifeAssured.Name = name;
    lifeAssured.Number = number;
    lifeAssured.Benefits = new Object;
    lifeAssured.MinAge = 100;
    lifeAssured.MaxAge = 0;
    return lifeAssured;
}

function Benefit(name, type, optional, matchBenefit, singleCoverAmount, maxAcrossLives, coverNotGreaterThanLife, coverNotLessThanLife) {

    var benefit = new Object;
    benefit.Name = name;
    benefit.Type = type;
    benefit.Optional = optional;
    benefit.MatchBenefit = matchBenefit;
    benefit.SingleCoverAmount = singleCoverAmount;
    benefit.MaxAcrossLives = maxAcrossLives;
    benefit.CoverNotGreaterThanLife = coverNotGreaterThanLife;
    benefit.CoverNotLessThanLife = coverNotLessThanLife;
    benefit.Rates = LoadRates(type);

    return benefit;
}

function Rate(startAge, endAge, coverAmount, premium) {
    var rate = new Object();
    rate.StartAge = startAge;
    rate.EndAge = endAge;
    rate.CoverAmount = coverAmount;
    rate.Premium = premium;
    return rate;
}




Number.prototype.format = function (n, x) {
    var re = '\\d(?=(\\d{' + (x || 3) + '})+' + (n > 0 ? '\\.' : '$') + ')';
    return this.toFixed(Math.max(0, ~~n)).replace(new RegExp(re, 'g'), '$&,');
};

function GE(object) {
    return document.getElementById(object);
}

function HideObject(hideCondition, object) {
    if (hideCondition) {
        $(object).hide();
    }
    else {
        $(object).show();
    }
}