﻿var ECM = ECM || {};

ECM.Helpers = function () {
    var initPopup = function () {
        $("#popup-dialog").on({
            popupbeforeposition: function () {
                var minWidth = $(window).width() - 60 + "px";
                $("#popup-dialog").css("min-width", minWidth);
                $('#popup-dialog #btn-ok').on('click', function() {
                    $("#popup-dialog").popup('close');
                });
            }
        });
    };

    initPopup();
};

ECM.Helpers.prototype.logMessage = function (message) {
    if (message) {
        console.log('---------> ' + message);
    }
};

ECM.Helpers.prototype.showNotification = function (message, title, isFatalError) {
    if (message) {
        title = title || 'ECM Calculator';

        if (isFatalError) {
            $('#popup-dialog').on('popupafterclose', function(e, ui) {
                window.navigator.app.exitApp();
            });
        }

        $('#popup-dialog .header-title').text(title);
        $('#popup-dialog .content').text(message);
        $('#popup-dialog').popup('open', { transition: 'slidedown' });

    }
}

ECM.Helpers.prototype.getLocalStorageValue = function (searchKey) {
    if (searchKey && searchKey.length == 0) {
        return '';
    }

    var localStorageSettingCount = window.localStorage.length;

    for (var i = 0; i < localStorageSettingCount; i++) {
        var key = window.localStorage.key(i);
        if (key == searchKey) {
            return window.localStorage.getItem(key);
        }
    }

    return '';
};

ECM.Helpers.prototype.setLocalStorageValue = function (key, value) {
    window.localStorage.setItem(key, value);
};

ECM.Helpers.prototype.showLoading = function () {
    $.mobile.loading('show', {
        text: 'Loading, please wait',
        textVisible: true,
    });
};

ECM.Helpers.prototype.hideLoading = function () {
    $.mobile.loading('hide');
};